C     Copyright (c) 2002, NAKANO Takeo All rights reserved.
C
C     Redistribution and use in source and binary forms, with or without
C     modification, are permitted provided that the following conditions
C     are met:
C
C     Redistributions of source code must retain the above copyright
C     notice, this list of conditions and the following disclaimer.
C
C     Redistributions in binary form must reproduce the above copyright
C     notice, this list of conditions and the following disclaimer in
C     the documentation and/or other materials provided with the
C     distribution.
C
C     Neither the name of the Seikei University nor the names of its
C     contributors may be used to endorse or promote products derived
C     from this software without specific prior written permission.
C
C     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
C     CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
C     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
C     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
C     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
C     BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
C     EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
C     TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
C     DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
C     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
C     TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
C     THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
C     SUCH DAMAGE.
C
#include "fopt.h"
      subroutine  ofstruc(X, NX)
C
C     output filter structure for SMA4Win
C
C     INPUT
C       X      :   node in amoeba's parameter space
C       NX     :   dimension of X
C
C     OUTPUT
C       NL     :   total number of layers (initially NLMAX)
C       RI(NL) :   refractive index
C       D(NL)  :   thickness
C
      integer NX
      double precision  X(NX)

      integer NL, NLMAX
      parameter (NLMAX = _NMAX_)
      double precision  RI(NLMAX), D(NLMAX), DSUM

      NL = NLMAX
      call fstruc(X, NX, NL, RI, D)

      write(0, 9000) NL
 9000 format('# NL: ', I5)

      DSUM = 0.D0
      write(0, 9010) RI(1)
      do 30 i=2, NL-1
         DSUM = DSUM + D(i)
         write(0, 9020) RI(i), DSUM
   30 continue
      write(0, 9010) RI(NL)

 9010 format ('# ', F20.9)
 9020 format (2F20.9)

      return
      end
