C     Copyright (c) 2002, NAKANO Takeo All rights reserved.
C
C     Redistribution and use in source and binary forms, with or without
C     modification, are permitted provided that the following conditions
C     are met:
C
C     Redistributions of source code must retain the above copyright
C     notice, this list of conditions and the following disclaimer.
C
C     Redistributions in binary form must reproduce the above copyright
C     notice, this list of conditions and the following disclaimer in
C     the documentation and/or other materials provided with the
C     distribution.
C
C     Neither the name of the Seikei University nor the names of its
C     contributors may be used to endorse or promote products derived
C     from this software without specific prior written permission.
C
C     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
C     CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
C     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
C     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
C     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
C     BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
C     EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
C     TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
C     DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
C     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
C     TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
C     THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
C     SUCH DAMAGE.
C
      PROGRAM test
C
C     sample program for amoeba
C
      INTEGER NP,MP
      PARAMETER(NP=20,MP=21)

      double precision FTOL

      INTEGER iter,ndim

      integer i, j
      double precision func, p(MP,NP), x(NP), y(MP)
      EXTERNAL func

      FTOL = 1.0D-3
      ndim=5

      do 1 i=1,ndim
         p(1,i) = 1.0D0
 1    continue

      do 2 j=2,ndim+1
         do 3 i=1, ndim
            p(j,i) = p(1,i)
 3       continue
         p(j,j-1) = p(j,j-1)*1.5D0
 2    continue

      do 12 j=1, ndim+1
         do 11 i=1,ndim
            x(i)=p(j,i)
 11      continue
         y(j)=func(x,ndim)
 12   continue
     
      do 6 j=1, ndim+1
         write(*,100) j, (p(j,i),i=1,ndim), y(j)
 6    continue
 100  format(' ',I3, 6F10.5)

      call amoeba(p,y,MP,NP,ndim,FTOL,func,iter)

      write(*,'(/1x,a,i3)') 'number of iterations',iter

      do 7 j=1, ndim+1
         write(*,100) j, (p(j,i),i=1,ndim), y(j)
 7    continue

      STOP
      END

      double precision FUNCTION func(x, nx)
      integer nx
      double precision x(nx)

      func = 0.d0
      do 10 i = 1, nx
         func = func + x(i)**2
 10   continue
      return
      END
